<?php

/*
 * itunes.php
 *
 * PHP Based iTunes Library Browser
 * Copyright (C) 2007-2009  Jason Barrie Morley
 * http://www.jbmorley.co.uk
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

if (!file_exists("settings.php"))
	{
	die("Cannot find 'settings.php'. Copy 'settings_example.php' to 'settings.php' and edit it to reflect your current configuration.");
	}
include("settings.php");


function itunes_connect()
	{
	global $databaseUser;
	global $databasePass;
	global $databaseName;
	global $databaseHost;
	global $iTunesXML;
	
	// Attempt to open a connection to the MySQL server.
	$link = mysql_connect($databaseHost, $databaseUser, $databasePass);
	if (!$link)
		{
		die('Could not connect: ' . mysql_error());
		}
		
	// Select the correct databse.
	mysql_select_db($databaseName);
	}

    
function itunes_disconnect()
	{
	mysql_close();
	}
    
function itunes_create_tables()
	{
	global $databaseUser;
	global $databasePass;
	global $databaseName;
	global $databaseHost;
	global $iTunesXML;
	
	// Initially, create the database if it does not exist.
	$sqlTableMusic =
		"CREATE TABLE IF NOT EXISTS `music` (" 
			. " `id` int(11) NOT NULL auto_increment,"
			. " `name` varchar(255) NOT NULL default '',"
			. " `artist` varchar(255) NOT NULL default '',"
			. " `type` varchar(15) NOT NULL default '',"
			. " `album` varchar(255) NOT NULL default '',"
			. " `genre` varchar(255) NOT NULL default '',"
			. " `location` varchar(400) NOT NULL default '',"
			. " `rating` int(11) NOT NULL default '0',"
			. "  PRIMARY KEY  (`id`)"
		. ") ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
	
	$sqlTableMeta =
		"CREATE TABLE IF NOT EXISTS `meta` ("
			. " `id` int(11) NOT NULL auto_increment,"
			. " `key` varchar(255) NOT NULL default '',"
			. " `value` varchar(255) NOT NULL default '',"
			. " PRIMARY KEY  (`id`)"
		. ") ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
	
	$result = mysql_query($sqlTableMusic);
	$result = mysql_query($sqlTableMeta);
	}
    	
function itunes_truncate_table()
	{
	$result = mysql_query("TRUNCATE TABLE `music`;");
	if (!$result)
		{
		die('Invalid query: '.mysql_error());
		}
	}
    	
function itunes_import_library()
	{
	global $iTunesXML;
	global $iTunesMusic;

	// Check the file exists.
	if (!file_exists($iTunesXML))
		{
		die("iTunes Library '".$iTunesXML."' could not be found");
		}

	// Work out the md5 of the data.
	$md5 = md5_file($iTunesXML);
	
	// Compare to the previous md5sum and only update the database if it has changed.
	$sql = "SELECT * FROM `meta` WHERE `key`='md5';";
	$result = mysql_query($sql);
	
	if (itunes_get_meta('hash') != $md5)
		{
		itunes_truncate_table();
		itunes_import();
		itunes_set_meta('hash', $md5);
		}
		
	// Create a SymLink for the iTunes library if one doesn't exist and we
	// are in the desired mode.
	if (isset($iTunesMusic))
		{
		if (itunes_get_meta('music_library') != $iTunesMusic)
			{
			itunes_set_meta('music_library', $iTunesMusic);
			if (file_exists('Music'))
				{
				unlink('Music');
				}			
			}
		
		if (!file_exists('Music'))
			{
			symlink($iTunesMusic, 'Music');
			}
		}

	}
	
/*
 * Updates the value for a specific meta data key.
 *
 */
function itunes_set_meta($key, $value)
	{
	$key   = mysql_real_escape_string($key);
	$value = mysql_real_escape_string($value);
	
	$result = mysql_query("DELETE FROM `meta` WHERE `key` = '".$key."' LIMIT 1");
	if (!$result)
		{
		die('Invalid query: '.mysql_error());
		}
		
	$result = mysql_query("INSERT INTO  `meta` ( `key` ,  `value` ) VALUES ( '".$key."',  '".$value."' );");
	if (!$result)
		{
		die('Invalid query: '.mysql_error());
		}
		
	}
	

/*
 * Retreives the value for specific meta data key.
 *
 * Returns false if the key does not exist. 
 *
 */
function itunes_get_meta($key)
	{
	$key = mysql_real_escape_string($key);
	
	$sql = "SELECT * FROM `meta` WHERE `key`='".$key."';";
	$result = mysql_query($sql);
	
	if (mysql_num_rows($result) == 0)
		{
		return false;
		}
	else
		{
		return mysql_result($result, 0, "value");
		}
	}
	

/*
 * Retrieves the track data for music tracks by ID.
 *
 * Returns false if the track does not exist.
 *
 */
function itunes_get_track($id)
	{	
	$id = mysql_real_escape_string($id);
	
	$sql = "SELECT * FROM `music` WHERE `id`=".$id.";";
	$result = mysql_query($sql);
	
	if (mysql_num_rows($result) == 0)
		{
		return false;
		}
	else
		{
		return mysql_fetch_assoc($result);
		}
	}

function itunes_initialize()
	{
	itunes_create_tables();
	itunes_import_library();
	}

    	
function add_row($name, $artist, $album, $genre, $rating, $type, $location)
	{
	if ($name != "")
		{
		if ($rating == "") { $rating = 0; } // Correct the rating.
		
		// Escape the various fields.
		$name     = mysql_real_escape_string($name);
		$artist   = mysql_real_escape_string($artist);
		$album    = mysql_real_escape_string($album);
		$genre    = mysql_real_escape_string($genre);
		$type     = mysql_real_escape_string($type);
		$location = mysql_real_escape_string($location);
		
		// Perform the insert.
		$sql = "INSERT INTO `music` (`name`, `artist`, `album`, `genre`, `rating`, `type`, `location`) VALUES ('$name', '$artist', '$album', '$genre', $rating, '$type', '$location');";
		$result = mysql_query($sql);
		if (!$result)
			{
			die('Invalid query: '.mysql_error());
			}
		}
	}
    
function startElementHandler($parser, $name, $attrib) {}

function endElementHandler($parser, $name)
	{
	global $parser_current_element;
	global $parser_current_key;
	global $parser_stack;
	global $parser_current_value;
	global $parser_structure;
	global $iTunesMusic;
	
	if ($name == "KEY")
		{
		$parser_current_key = $parser_current_value;
		array_push($parser_stack, $parser_current_key);
		}
	else if ($name == "DICT")
		{
		if ($parser_stack[0] == "Tracks")
			{
			// Work out the type.
			$type = "Music"; // Default to 'Music',
			if ($parser_structure["Movie"] == "TRUE")       { $type = "Movie"; }
			if ($parser_structure["TV Show"] == "TRUE")     { $type = "TV Show"; }
			if ($parser_structure["Music Video"] == "TRUE") { $type = "Music Video"; }
			if ($parser_structure["Podcast"] == "TRUE")     { $type = "Podcast"; }


			
			$location = urldecode($parser_structure["Location"]);
			
			if (isset($iTunesMusic))
				{
				$location_prefix = "file://localhost".$iTunesMusic;
				$location = "Music".str_replace($location_prefix, "", $location);
				}
			else
				{
				$location = "";
				}
				
			$hasVideo = $parser_structure["Movie"] == "TRUE" ? "1" : "0";
				
			add_row
				(
				$parser_structure["Name"],
				$parser_structure["Artist"],
				$parser_structure["Album"],
				$parser_structure["Genre"],
				$parser_structure["Rating"],
				$type,
				$location
				);
			
			}
		$parser_structure = array();
		}
	
	if ($name != "KEY")
		{
		array_pop($parser_stack);
		if ($name == "TRUE" || $name == "FALSE")
			{
			$parser_structure[$parser_current_key] = $name;				
			}
		else
			{
			$parser_structure[$parser_current_key] = $parser_current_value;
			}
		}
		
	$parser_current_value = "";
	}

function characterDataHandler($parser, $data)
	{
	global $parser_current_value;
	$data = trim($data);
	$parser_current_value .= $data;
	}

function itunes_import()
	{
	global $parser_structure, $parser_stack, $parser_current_key, $parser_current_value, $iTunesXML;
	
	$parser_stack         = array();
	$parser_structure     = array();
	$parser_current_key   = "";
	$parser_current_value = "";

	if (!($fp=@fopen($iTunesXML, "r"))) die ("Couldn't open XML.");
	if (!($xml_parser = xml_parser_create())) die("Couldn't create parser.");

	xml_set_element_handler($xml_parser,"startElementHandler","endElementHandler");
	xml_set_character_data_handler( $xml_parser, "characterDataHandler");
	
	while( $data = fread($fp, 4096))
		{
		if(!xml_parse($xml_parser, $data, feof($fp))) { break; }
		}
	xml_parser_free($xml_parser);
	
	}
		

?>